; Empire of Firebird 1985

.ifdef sid
 .byte "PSID"
 .word $0200         ; version 2
 .word $7C00         ; data offset
 .word $0000         ; load address in cbm format
 .byte >initMusic
 .byte <initMusic
 .byte >irqMusic
 .byte <irqMusic
 .word $1600         ; 1 song
 .word $0700         ; default song
 .word $0000;FFFF
 .word 00000;$FFFF
 .byte "Empire",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .byte "<?>",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .byte "1985 Firebird",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .word $0000
 .word $0000
 .word $0000

.byte 01
.byte 08

.org $0801

.else

 ;=================================
 ; PRG start address
 ;=================================
 .byte $01,$08

 ;=================================
 ; BASIC startup program
 ;=================================
 .byte $0b,$08,$e8,$03,$9e,"2061",0,0,0
 .org 2061

  jsr initMusic

   sei
   lda #<interr
   sta $0314
   lda #>interr
   sta $0315
      ldx  #$00
      stx  $DC0E       ; Control register A of CIA #1
      inx
      stx  $D01A       ; IRQ mask register
   cli

aaa:
 jmp aaa

interr =*
      lda  #$01
      sta  $D019       ; Interrupt indicator register
      lda  #$82
      sta  $D012       ; Reading/Writing IRQ balance value
      lda  #$1B
      sta  $D011       ; VIC control register
      lda  #$01
      sta  $D020       ; Border color

   jsr irqMusic

   dec  $D020       ; Border color

   jmp $ea31
.endif


initMusic:
      pha
      jsr  initFilter
      pla
      cmp  #$08
      bpl  sound

      sta nextPatt
      sta actualPatt
      lda  #$00
      sta  $2C
      rts

sound:
      sec
      sbc  #$08
      asl
      tax

      lda  #$40
      sta  $2C
      jsr soundB
      rts


sDuration:                        ; duration of sound
  .byte $00
sFLow:                            ; sound freq low
  .byte $00
sFHi:                             ; sound freq hi
  .byte $00

 .byte $00, $00, $00

 .byte $00, $0C, $FE

freqA1Lo:
  .byte $00                       ; freq low
freqA1Hi:
  .byte $00                       ; freq hi
;0559
  .byte $00
  .byte $00
controlA:
  .byte $00                       ; control
AD_A:
  .byte $00                       ; A/D
SR_A:
  .byte $00                       ; S/R

;055E
  .byte $00                       ; freq low
  .byte $00                       ; freq hi
  .byte $00
  .byte $00
  .byte $00                       ; control
  .byte $00                       ; A/D
  .byte $00                       ; S/R

;0565
  .byte $00                       ; freq low
  .byte $00                       ; freq hi
  .byte $00
  .byte $00
  .byte $10                       ; control
  .byte $0F                       ; A/D
  .byte $00                       ; S/R

speed1:
  .byte $07
speed2:
  .byte $07

noteLen1:
  .byte $04                       ; note length 1
notelen2:
  .byte $04                       ; note length 2

actPat1Off:                       ; actual pattern offset voice 1
  .byte $00
actPat2Off:                       ; actual pattern offset voice 2
  .byte $00

nextPatt:
  .byte $07

indexToPatt:                      ; index to the pattern from the track
  .byte $05

actualPatt:
  .byte $07                       ; actual pattern pointer voice 1 and 2

noteFreq1Hi:
  .byte $02
noteFreq1Lo:
  .byte $25

noteFreq2Hi:
  .byte $73
noteFreq2Lo:
  .byte $58

instr1Num:
  .byte $02                       ; number of instrument for voice 1
instr2Num:
  .byte $00                       ; number of instrument for voice 2

flag1:                            ; flag for inc/dec effect
  .byte $00
flag2:
  .byte $00

; as above for other voice
  .byte $00, $00

cutDirFlag:                       ; cut direction flag 0=add 1=dec
  .byte $01

instrumV1:                        ; instrument voice 1
  .byte $C0, $08, $41, $0F, $0F   ; low wav, hi wav, form, A/D, S/R

instrumV2:                        ; instrument voice 2
  .byte $00, $00, $81, $09, $00   ; low wav, hi wav, form, A/D, S/R



irqMusic:
      bit $2C
      bmi noSound

      jsr makeSound

noSound:
      bit $2C
      bvs noMusic

      jsr callMakeMusic

noMusic:
      rts


callMakeMusic:
      jsr  makeMusic
      jsr  makeMusic
      jmp  makeMusic

initFilter:
      lda  #$1F
      sta  $D418                  ; Select volume and filter mode

      lda  #$F1
      sta  $D417                  ; Filter resonance control/voice input control

      lda  #$07
      sta  $D415                  ; Filter cut frequency: lo byte (bit 2-0)

      lda  #$07
      sta  $03                    ; speed of song
      sta  speed1
      sta  speed2

      lda  #$01
      sta  noteLen1               ; note length 1
      sta  notelen2               ; note length 2

      lda  #$A8
      sta  $04
      sta  $D416                  ; Filter cut frequency: hi byte
      rts

eraseADSR1:
      ldx  #$04
      bne  erasingParam

eraseADSR2:
      ldx  #$0B

erasingParam:
      lda  #$00
      sta  $D400,x                ; Voice 1: Frequency control (lo byte)
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)
      sta  $D402,x                ; Voice 1: Wave form pulsation amplitude (lo byte)
      rts

makeMusic:
      lda  $03                    ; speed of song (delay)
      beq  makeMusic1
      dec  $03
      rts

makeMusic1:
      dec  noteLen1               ; dec note length 1
      lda  noteLen1               ; read note length 1
      beq  readNote1

      lda  instr1Num              ; number of instrument for voice 1
      and  #$F0                   ; instrument effect?
      beq  noEffect1
      tay
      lda  noteFreq1Lo
      ldx  noteFreq1Hi
      cpy  #$10
      bne  isDecEff1

incEff1:
      jsr  incFreq
      jmp  setFreq1

isDecEff1:
      cpy  #$20
      bne  incDecEff1

decEff1:
      jsr  decFreq
      jmp  setFreq1

incDecEff1:
      ldy  #$00
      jsr  incDecEff

setFreq1:
      sta  noteFreq1Lo
      sta  $D400                  ; Voice 1: Frequency control (lo byte)
      stx  noteFreq1Hi
      stx  $D401                  ; Voice 1: Frequency control (hi byte)
noEffect1:
      jmp  makeMusic2

readNote1:
      ldy  actPat1Off             ; actual pattern offset voice 1
      lda  actualPatt
      asl  a
      tax
      lda  noteLen1pnt,x          ; pointer to note length for voice 1
      sta  $05
      lda  noteLen1pnt+1,x
      sta  $06
      lda  ($05),y
      sta  noteLen1               ; note length 1
      lda  numInst1pnt,x          ; pointer to number of instrument for voice 1
      sta  $05
      lda  numInst1pnt+1,x
      sta  $06
      lda  ($05),y
      sta  instr1Num              ; number of instrument for voice 1
      lda  note1pnt,x             ; note to play for voice 1
      sta  $05
      lda  note1pnt+1,x
      sta  $06
      lda  ($05),y                ; note to play
      cmp  #$FF                   ; end pattern?
      bne  noEndPattern1

endPattern1:
      lda  nextPatt
      cmp  actualPatt
      beq  noResetPatt

      lda  #$00
      sta  actPat1Off             ; actual pattern offset voice 1
      sta  actPat2Off             ; actual pattern offset voice 2

noResetPatt:
      lda  nextPatt
      sta  actualPatt
      lda  speed2
      sta  speed1
      lda  #$00
      sta  actPat1Off             ; actual pattern offset voice 1
      beq  readNote1

noEndPattern1:
      tay                         ; note to play
      lda  #$00
      sta  flag1
      sta  flag2
      lda  freqLoTable,y
      sta  $D400                  ; Voice 1: Frequency control (lo byte)
      sta  noteFreq1Lo
      lda  freqHiTable,y
      sta  $D401                  ; Voice 1: Frequency control (hi byte)
      sta  noteFreq1Hi
      jsr  eraseADSR1

      lda  instr1Num              ; number of the instrument for voice 1
      and  #$0F
      asl  a
      tay
      lda  instrTable,y           ; instrTable low pointer
      sta  $05
      lda  instrTable+1,y         ; instrTable hi pointer
      sta  $06
      ldy  #$00

loopV1:
      lda  ($05),y                ; read instrument characteristics
      sta  $D402,y                ; Voice 1: Wave form pulsation amplitude (lo byte)
      sta  instrumV1,y
      iny
      cpy  #$05
      bne  loopV1

      inc  actPat1Off            ; actual pattern offset voice 1

makeMusic2:
      dec  notelen2              ; dec note length 2
      lda  notelen2              ; read note length 2
      beq  readNote2

      lda  instr2Num             ; number of instrument for voice 2
      and  #$F0                  ; instrument effect?
      beq  noEffect2
      tay
      lda  noteFreq2Lo
      ldx  noteFreq2Hi
      cpy  #$10
      bne  isDecEff2

incEff2:
      jsr  incFreq
      jmp  setFreq2

isDecEff2:
      cmp  #$20
      bne  incDecEff2

decEff2:
      jsr  decFreq
      jmp  setFreq2

incDecEff2:
      ldy  #$02
      jsr  incDecEff

setFreq2:
      sta  noteFreq2Lo
      sta  $D407                  ; Voice 2: Frequency control (lo byte)
      stx  noteFreq2Hi
      stx  $D408                  ; Voice 2: Frequency control (hi byte)
noEffect2:
      jmp  addWave

readNote2:
      ldy  actPat2Off             ; actual pattern offset voice 2
      lda  actualPatt
      asl  a
      tax
      lda  noteLen2pnt,x          ; pointer to note length for voice 2
      sta  $05
      lda  noteLen2pnt+1,x
      sta  $06
      lda  ($05),y
      sta  notelen2               ; note length 2
      lda  numInst2pnt,x          ; pointer to number of instrument for voice 2
      sta  $05
      lda  numInst2pnt+1,x
      sta  $06
      lda  ($05),y
      sta  instr2Num              ; number of instrument for voice 2
      lda  note2pnt,x             ; note to play for voice 2
      sta  $05
      lda  note2pnt+1,x
      sta  $06
      lda  ($05),y                ; note to play
      cmp  #$FF                   ; end?
      bne  noEndPattern2

endPattern2:
      lda  #$00
      sta  actPat2Off             ; actual pattern offset voice 2
      beq  readNote2

noEndPattern2:
      tay
      lda  #$00
      sta  $057D
      sta  $057E
      lda  freqLoTable,y
      sta  $D407                  ; Voice 2: Frequency control (lo byte)
      sta  noteFreq2Lo
      lda  freqHiTable,y
      sta  $D408                  ; Voice 2: Frequency control (hi byte)
      sta  noteFreq2Hi
      jsr  eraseADSR2

      lda  instr2Num              ; number of instrument for voice 2
      and  #$0F
      asl  a
      tay
      lda  instrTable,y           ; instrTable low pointer
      sta  $05
      lda  instrTable+1,y         ; instrTable hi pointer
      sta  $06
      ldy  #$00

loopV2:
      lda  ($05),y
      sta  $D409,y                ; Voice 2: Wave form pulsation amplitude (lo byte)
      sta  instrumV2,Y
      iny
      cpy  #$05
      bne  loopV2

      inc  actPat2Off             ; actual pattern offset voice 2

addWave:
      jsr  addWaveFreq
      lda  speed1
      sta  $03                    ; speed of song
      rts

incFreq:                          ; increment frequency
      clc
      adc  #$50
      bcc  endIF
      inx
endIF:
      rts

decFreq:                          ; decrement frequency
      sec
      sbc  #$50
      bcs  endDF
      dex
endDF:
      rts

incDecEff:
      stx  $08
      sta  $07
      tya
      tax
      lda  flag1,x
      bne  decFlag2

      inc  flag2,x
      lda  flag2,x
      cmp  #$02
      bne  goIncFreq

      lda  #$01
      sta  flag1,x

goIncFreq:
      ldx  $08
      lda  $07
      jmp  incFreq

decFlag2:
      dec  flag2,x
      lda  flag2,x
      bne  goDecFreq
      lda  #$00
      sta  flag1,x

goDecFreq:
      ldx  $08
      lda  $07
      jmp  decFreq

addWaveFreq:
      lda  instrumV1              ; wave low
      clc
      adc  #$30
      bcc  skipWHI
      inc  instrumV1+1            ; wave high

skipWHI:
      sta  instrumV1              ; wave low
      sta  $D402                  ; Voice 1: Wave form pulsation amplitude (lo byte)
      lda  instrumV1+1            ; wave high
      sta  $D403                  ; Voice 1: Wave form pulsation amplitude (hi byte)
      lda  cutDirFlag             ; cut direction flag 0=add 1=dec
      bne  decCutFreq

addCutFreq:
      lda  $04
      clc
      adc  #$07
      sta  $04
      sta  $D416                  ; Filter cut frequency: hi byte
      cmp  #$FC
      bne  noDec
      lda  #$01                   ; dec cut flag
      sta  cutDirFlag             ; cut direction flag 0=add 1=dec
noDec:
      rts

decCutFreq:
      lda  $04
      sec
      sbc  #$07
      sta  $04
      sta  $D416                  ; Filter cut frequency: hi byte
      cmp  #$A8
      bne  noAdd
      lda  #$00                   ; add cut flag
      sta  cutDirFlag             ; cut direction flag 0=add 1=dec
noAdd:
      rts

freqLoTable:
  .byte $25, $45, $68, $8C, $B3, $DC, $08, $36
  .byte $67, $9B, $D2, $0C, $49, $8B, $D0, $19
  .byte $67, $B9, $10, $6C, $CE, $35, $A3, $17
  .byte $93, $15, $9F, $3C, $CD, $72, $20, $D8
  .byte $9C, $6B, $46, $2F, $25, $2A, $3F, $64
  .byte $9A, $E3, $3F, $B1, $38, $D6, $8D, $5E
  .byte $4B, $55, $7E, $C8, $34, $C6, $7F, $61
  .byte $6F, $AC, $7E, $BC, $95, $A9, $FC, $A1
  .byte $69, $8C, $FE, $C2, $DF, $58, $34, $78
  .byte $53, $00

freqHiTable:
  .byte $02, $02, $02, $02, $02, $02, $03, $03
  .byte $03, $03, $03, $04, $04, $04, $04, $05
  .byte $05, $05, $06, $06, $06, $07, $07, $08
  .byte $08, $09, $09, $0A, $0A, $0B, $0C, $0C
  .byte $0D, $0E, $0F, $10, $11, $12, $13, $14
  .byte $15, $16, $18, $19, $1B, $1C, $1E, $20
  .byte $22, $24, $26, $28, $2B, $2D, $30, $33
  .byte $36, $39, $3D, $40, $44, $48, $4C, $51
  .byte $56, $5B, $60, $66, $6C, $73, $7A, $81
  .byte $89, $00

instrTable:
  .byte <instr0, >instr0
  .byte <instr1, >instr1
  .byte <instr2, >instr2
  .byte <instr3, >instr3
  .byte <instr4, >instr4
  .byte <instr5, >instr5

instr0:
  .byte $00, $00, $81, $09, $00   ; low wav, hi wav, form, A/D, S/R
instr1:
  .byte $50, $08, $41, $0A, $0F
instr2:
  .byte $50, $06, $41, $0F, $0F
instr3:
  .byte $50, $0C, $41, $0C, $00
instr4:
  .byte $50, $0C, $81, $06, $00
instr5:
  .byte $50, $02, $41, $FC, $74

note1pnt:                         ; note to play for voice 1
  .byte <note1tr1, >note1tr1
  .byte <note1tr2, >note1tr2
  .byte <note1tr3, >note1tr3
  .byte <note1tr4, >note1tr4
  .byte <note1tr5, >note1tr5
  .byte <note1tr6, >note1tr6
  .byte <note1tr7, >note1tr7
  .byte <note1tr8, >note1tr8

note2pnt:                         ; note to play for voice 2
  .byte <note2tr1, >note2tr1
  .byte <note2tr2, >note2tr2
  .byte <note2tr3, >note2tr3
  .byte <note2tr4, >note2tr4
  .byte <note2tr5, >note2tr5
  .byte <note2tr6, >note2tr6
  .byte <note2tr7, >note2tr7
  .byte <note2tr8, >note2tr8

noteLen1pnt:                      ; pointer to note length for voice 1
  .byte <len1tr1, >len1tr1
  .byte <len1tr2, >len1tr2
  .byte <len1tr3, >len1tr3
  .byte <len1tr4, >len1tr4
  .byte <len1tr5, >len1tr5
  .byte <len1tr6, >len1tr6
  .byte <len1tr7, >len1tr7
  .byte <len1tr8, >len1tr8

noteLen2pnt:                      ; pointer to note length for voice 2
  .byte <len2tr1, >len2tr1
  .byte <len2tr2, >len2tr2
  .byte <len2tr3, >len2tr3
  .byte <len2tr4, >len2tr4
  .byte <len2tr5, >len2tr5
  .byte <len2tr6, >len2tr6
  .byte <len2tr7, >len2tr7
  .byte <len2tr8, >len2tr8

numInst1pnt:                      ; pointer to number of instrument for voice 1
  .byte <instr1tr1, >instr1tr1
  .byte <instr1tr2, >instr1tr2
  .byte <instr1tr3, >instr1tr3
  .byte <instr1tr4, >instr1tr4
  .byte <instr1tr5, >instr1tr5
  .byte <instr1tr6, >instr1tr6
  .byte <instr1tr7, >instr1tr7
  .byte <instr1tr8, >instr1tr8

numInst2pnt:                      ; pointer to number of instrument for voice 2
  .byte <instr2tr1, >instr2tr1
  .byte <instr2tr2, >instr2tr2
  .byte <instr2tr3, >instr2tr3
  .byte <instr2tr4, >instr2tr4
  .byte <instr2tr5, >instr2tr5
  .byte <instr2tr6, >instr2tr6
  .byte <instr2tr7, >instr2tr7
  .byte <instr2tr8, >instr2tr8

note1tr1:
  .byte $0C, $0F, $0C, $0A
  .byte $FF
len1tr1:
  .byte $10, $10, $10, $10
instr1tr1:
  .byte $02, $02, $02, $02

note2tr1:
  .byte $18, $1B, $18, $16
  .byte $FF
len2tr1:
  .byte $10, $10, $10, $10
instr2tr1:
  .byte $02, $02, $02, $02

note1tr2:
  .byte $0C, $18, $13, $0A
  .byte $07, $0A, $0C, $0C
  .byte $0C, $0F, $13, $0A
  .byte $FF
len1tr2:
  .byte $0A, $05, $05, $0A
  .byte $05, $05, $0A, $05
  .byte $05, $0A, $05, $05
instr1tr2:
  .byte $03, $03, $03, $03
  .byte $03, $03, $03, $03
  .byte $03, $03, $03, $03

note2tr2:
  .byte $18, $41, $18, $16
  .byte $41, $16, $18, $41
  .byte $18, $1B, $41, $16
  .byte $FF
len2tr2:
  .byte $0A, $05, $05, $0A
  .byte $05, $05, $0A, $05
  .byte $05, $0A, $05, $05
instr2tr2:
  .byte $03, $04, $23, $03
  .byte $04, $13, $03, $04
  .byte $13, $03, $04, $13

note1tr3:
  .byte $2E, $30, $30, $30
  .byte $30, $30, $30, $2E
  .byte $FF
len1tr3:
  .byte $08, $08, $08, $08
  .byte $08, $08, $08, $08
instr1tr3:
  .byte $12, $32, $32, $32
  .byte $32, $32, $32, $32

note2tr3:
  .byte $18, $17, $16, $15
  .byte $FF
len2tr3:
  .byte $10, $10, $10, $10
instr2tr3:
  .byte $02, $02, $02, $02

note1tr4:
  .byte $0C
  .byte $FF
len1tr4:
  .byte $20
instr1tr4:
  .byte $02

note2tr4:
  .byte $00, $00
  .byte $FF
len2tr4:
  .byte $10, $10
instr2tr4:
  .byte $01, $01

note1tr5:
  .byte $24, $24, $22, $22
  .byte $FF
len1tr5:
  .byte $10, $10, $10, $10
instr1tr5:
  .byte $32, $22, $32, $12

note2tr5:
  .byte $0C, $0C, $0A, $0A
  .byte $FF
len2tr5:
  .byte $10, $10, $10, $10
instr2tr5:
  .byte $02, $02, $02, $02

note1tr6:
  .byte $24, $25
  .byte $FF
len1tr6:
  .byte $18, $18
instr1tr6:
  .byte $35, $35

note2tr6:
  .byte $0C, $0C, $0C, $0D
  .byte $0D, $0D
  .byte $FF
len2tr6:
  .byte $08, $08, $08, $08
  .byte $08, $08
instr2tr6:
  .byte $03, $03, $03, $03
  .byte $03, $03

note1tr7:
  .byte $00
  .byte $FF
len1tr7:
  .byte $20
instr1tr7:
  .byte $01

note2tr7:
  .byte $45, $45, $45, $45
  .byte $45, $45, $45, $45
  .byte $45, $45, $45
  .byte $FF
len2tr7:
  .byte $08, $08, $04, $04
  .byte $04, $04, $08, $08
  .byte $08, $04, $04
instr2tr7:
  .byte $00, $04, $04, $04
  .byte $04, $04, $00, $04
  .byte $00, $04, $04

note1tr8:
  .byte $00, $03, $02, $03
  .byte $05
  .byte $FF
len1tr8:
  .byte $10, $10, $10, $08
  .byte $08
instr1tr8:
  .byte $02, $02, $02, $02
  .byte $02

note2tr8:
  .byte $45, $45, $45, $45
  .byte $45, $45, $45, $45
  .byte $45, $45, $45
  .byte $FF
len2tr8:
  .byte $08, $08, $08, $04
  .byte $04, $08, $04, $04
  .byte $08, $04, $04
instr2tr8:
  .byte $00, $00, $00, $04
  .byte $04, $00, $04, $04
  .byte $00, $04, $04



soundA:
      tya
      pha
      ldy  #$00
      tya
      beq  jump

soundB:
      tya
      pha
      ldy  #$07
      lda  #$03
      bne  jump

soundC:
      tya
      pha
      ldy  #$0E
      lda  #$06

jump:
      bit  $2C
      bvs  skipForMus

      ldy  #$0E
      lda  #$06

skipForMus:
      sta  addr+1
      lda  tabFreq,x
      sta  freqA1Lo,y             ; frequency low
      lda  tabFreq+1,x
      sta  freqA1Hi,y             ; frequency high
      lda  tabADSR,x
      sta  AD_A,y                 ; A/D
      lda  tabADSR+1,x
      sta  SR_A,y                 ; S/R
      lda  tabCtrlDur,x
      sta  controlA,y             ; control
addr:
      ldy  #$06
      lda  tabCtrlDur+1,x
      sta  sDuration,y            ; duration
      lda  tabDeltaFreq,x
      sta  sFLow,y
      lda  tabDeltaFreq+1,x
      sta  sFHi,y
      pla
      tay
      rts

makeSound:
      ldx  #$00                   ; voice 1 if there's not music
      ldy  #$00

      bit  $2C
      bvs  skip

      ldx  #$06                   ; voice 3 if there's music
      ldy  #$0E

skip:
      lda  sDuration,x            ; duration
      beq  isZero
      dec  sDuration,x
      lda  sFLow,x
      clc
      adc  freqA1Lo,y             ; frequency low
      sta  freqA1Lo,y             ; store in frequency low
      lda  freqA1Hi,y             ; frequency hi
      adc  sFHi,x
      sta  freqA1Hi,y             ; store in frequency hi

isZero:
      lda  freqA1Lo,y
      sta  $D400,y                ; Voice 1: Frequency control (lo byte)
      lda  freqA1Hi,y
      sta  $D401,y                ; Voice 1: Frequency control (hi byte)
      lda  AD_A,y
      sta  $D405,y                ; Generator 1: Attack/Decay
      lda  SR_A,y
      sta  $D406,y                ; Generator 1: Sustain/Release
      lda  controlA,y
      sta  $D404,y                ; Voice 1: Control registers
      lda  sDuration,x            ; duration
      bne  notZero

      lda  $D404,y                ; Voice 1: Control registers
      and  #$FE
      sta  $D404,y                ; Voice 1: Control registers
      sta  controlA,y             ; control
notZero:
      inx
      inx
      inx
      tya
      clc
      adc  #$07
      tay
      cpy  #$15
      bcc  skip
      rts

; control, duration
tabCtrlDur:
  .byte $81, $96
  .byte $11, $96
  .byte $81, $05
  .byte $11, $12
  .byte $21, $05
  .byte $81, $05
  .byte $81, $5A
  .byte $11, $03
  .byte $81, $7D
  .byte $11, $14
  .byte $11, $04
  .byte $81, $12
  .byte $81, $04
  .byte $81, $12

; freq lo/hi
tabFreq:
  .byte $08, $52
  .byte $08, $52
  .byte $D0, $07
  .byte $28, $23
  .byte $70, $17
  .byte $BC, $02
  .byte $84, $03
  .byte $3C, $0F
  .byte $28, $23
  .byte $88, $13
  .byte $38, $4A
  .byte $30, $75
  .byte $90, $01
  .byte $30, $75

tabDeltaFreq:
  .byte $5E, $01
  .byte $5E, $01
  .byte $D4, $FE
  .byte $0C, $FE
  .byte $18, $FC
  .byte $00, $00
  .byte $F6, $FF
  .byte $E2, $FF
  .byte $90, $01
  .byte $FE, $FF
  .byte $FE, $FF
  .byte $18, $FC
  .byte $14, $00
  .byte $A8, $FD

; A/D, S/R
tabADSR:
  .byte $D6, $04
  .byte $D6, $04
  .byte $08, $00
  .byte $0F, $00
  .byte $48, $49
  .byte $08, $FA
  .byte $09, $DA
  .byte $00, $C8
  .byte $D0, $00
  .byte $09, $00
  .byte $0D, $00
  .byte $A0, $D6
  .byte $00, $55
  .byte $49, $33

setPatt1:
      sta  indexToPatt

setPatt2:
      cmp  indexToPatt
      bcc  skipReadPatt

      sta  indexToPatt
      tax
      lda  trackMus,x
      sta  nextPatt

skipReadPatt:
      rts

trackMus:
  .byte $06, $04, $03, $00, $00, $07, $05
  .byte $01, $00, $00, $00, $02
